#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

#define MAXN 500100
#define MAXK 1024

vector<pair<int,int> > ar[MAXN];
pair<int,int> prev[MAXN];
int dist[MAXN];
int N,M,K;

int s[MAXN];
int vis[MAXN];

int pos[MAXN];
int pp = 1;

int L = 0;
int dfs (int v) {
    dist[v] = L;
    for (int i=0; i<ar[v].size(); i++) {
        L += ar[v][i].second;
        dfs(ar[v][i].first);
        L -= ar[v][i].second;
    }
    pos[v] = pp++;
    return 0;
}

int l[21][2*MAXN];
int seen[MAXN];

int lca (int aa,int bb) {
    int a = min(seen[aa],seen[bb]);
    int b = max(seen[aa],seen[bb]);
    int m = MAXN*MAXK;

    int c = 0;
    int d = b - a + 1;
    while (d >= (1<<c)) {
          if ( (d&(1<<c)) != 0) {
             b -= (1<<c);
             if (m > dist[l[c][b+1]]) {
                m = dist[l[c][b+1]];
             }
          }
          c++;
    }
    return m;
}

int calc() {
    for (int i=1; i<=20; i++) {
        for (int j=1; j<=N*2-1; j++) {
            int r = min(j+(1<<(i-1)),2*N-1);
            if (dist[l[i-1][j]] < dist[l[i-1][r]]) {
               l[i][j] = l[i-1][j];
            } else {
               l[i][j] = l[i-1][r];
            }
        }
        printf("");
    }
}

int read() {
    scanf("%d%d%d",&N,&M,&K);
    for (int i=0; i<M; i++) {
        int a,b,c;
        scanf("%d%d%d",&a,&b,&c);
        prev[b].first = a;
        prev[b].second = c;
        ar[a].push_back(make_pair(b,c));
    }

    dfs(1);
    
    int f = 1;
    int cur = 1;
    int cid[MAXN];
    memset(cid,0,sizeof(cid));
    while (f <= 2*N-1) {
          l[0][f] = cur;
          if (seen[cur] == 0) seen[cur] = f;
          f++;
          if (cid[cur] >= ar[cur].size()) {
             cur = prev[cur].first;
          } else {
            cid[cur]++;
            cur = ar[cur][cid[cur]-1].first;
          }
    }
    calc();
    
    return 0;
}


int solve () {
    scanf("%d",&M);
    for (int i=0; i<M; i++) {
        scanf("%d",&s[i]);
    }

    long long ans = 0;
    vector<pair<int,int> > t;
    for (int i=0; i<M; i++) {
        t.push_back(make_pair(pos[s[i]],s[i]));
    }
    sort(t.begin(),t.end());

    if (M == 1) {
       printf("%lld\n",dist[s[0]]);
       return 0;
    }
    for (int i=0; i<M; i++) {
        if ( i == 0 ) {
           ans += dist[t[i].second] - lca(t[i].second,t[i+1].second)/2;
        } else if (i == M-1) {
          ans += dist[t[i].second] - lca(t[i].second,t[i-1].second)/2;
        } else {
          ans += dist[t[i].second] - max( lca(t[i-1].second,t[i].second),
                                          lca(t[i].second,t[i+1].second))/2;
        }
    }
    
    printf("%lld\n",ans);
    return 0;
}

int main () {
 //  freopen("lesna.in","r",stdin);
 //   freopen("lesna.out","w",stdout);

    read();
    for (int i=0; i<K; i++) {
        solve();
    }
    
    return 0;
}
